Index: trunk/i18n/uk.ts
===================================================================
--- trunk/i18n/uk.ts	(revision 53)
+++ trunk/i18n/uk.ts	(revision 54)
@@ -37,6 +37,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
@@ -47,6 +47,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unable to load task:</source>
         <translation>Неможливо завантажити умову:</translation>
@@ -66,5 +66,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -74,5 +74,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -81,17 +81,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
         <source>Unable to create task file.
 Error: %1
@@ -102,11 +102,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -118,27 +118,29 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="137"/>
+        <location filename="../src/tspsolver.cpp" line="138"/>
         <source>%v of %m parts found</source>
         <translation>Знайдено %v з %m переходів</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="141"/>
+        <location filename="../src/tspsolver.cpp" line="142"/>
         <source>Calculating optimal route...</source>
         <translation>Обчислення оптимального шляху...</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="142"/>
+        <location filename="../src/tspsolver.cpp" line="143"/>
         <source>Solution Progress</source>
         <translation>Поступ розв&apos;зку</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
+        <location filename="../src/tspsolver.cpp" line="209"/>
         <source>Solution Result</source>
         <translation>Результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
-        <source>This task has no solution.</source>
-        <translation>У цієї задачі немає розв&apos;язку.</translation>
+        <location filename="../src/tspsolver.cpp" line="209"/>
+        <source>Unable to find solution.
+Maybe, this task has no solutions.</source>
+        <translation>Не вдалося знайти розв&apos;язок.
+Можливо, у задачі немає розв&apos;зку.</translation>
     </message>
 </context>
@@ -146,107 +148,124 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="87"/>
-        <location filename="../ui/mainwindow.ui" line="75"/>
+        <location filename="../ui/mainwindow.ui" line="78"/>
         <source>Number of variant</source>
         <translation>Номер варіанту</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="110"/>
-        <location filename="../ui/mainwindow.ui" line="98"/>
+        <location filename="../ui/mainwindow.ui" line="101"/>
         <source>Number of cities</source>
         <translation>Кількість міст, що проходить комівояжер</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="271"/>
-        <location filename="../ui/mainwindow.ui" line="259"/>
+        <location filename="../ui/mainwindow.ui" line="288"/>
+        <source>Save &amp;As</source>
+        <translation>Зберегти &amp;як</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="310"/>
         <source>Select language</source>
         <translation>Вибір мови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="274"/>
-        <location filename="../ui/mainwindow.ui" line="262"/>
+        <location filename="../ui/mainwindow.ui" line="313"/>
         <source>Select application language</source>
         <translation>Обрати мову додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="322"/>
-        <source>P&amp;rint Setup...</source>
-        <translation>&amp;Налагодження друку...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="325"/>
-        <source>Setup printing</source>
-        <translation>Налагодити друк</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="337"/>
+        <location filename="../ui/mainwindow.ui" line="349"/>
+        <source>Toolbar</source>
+        <translation>Панель інструментів</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="374"/>
+        <source>P&amp;rint Preview...</source>
+        <translation>&amp;Попередній перегляд...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="377"/>
+        <source>Print Preview...</source>
+        <translation>Попередній перегляд...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="380"/>
+        <source>Preview solution results</source>
+        <translation>Попередній перегляд результатів розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="383"/>
+        <source>Preview current solution results before printing</source>
+        <translation>Попередній перегляд результатів розв&apos;язку перед друком</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="395"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="340"/>
-        <source>Print solution results</source>
-        <translation>Роздрукувати результат розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="343"/>
+        <location filename="../ui/mainwindow.ui" line="398"/>
+        <source>Print...</source>
+        <translation>Друк...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="401"/>
+        <source>Print solution</source>
+        <translation>Друк розв&apos;зку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="404"/>
+        <source>Print current solution results</source>
+        <translation>Роздрукувати поточний результат розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="407"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="356"/>
-        <location filename="../ui/mainwindow.ui" line="379"/>
+        <location filename="../ui/mainwindow.ui" line="415"/>
         <source>&amp;Solution...</source>
         <translation>&amp;Розв&apos;язок...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="559"/>
+        <location filename="../ui/mainwindow.ui" line="601"/>
         <source>Save</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="514"/>
-        <location filename="../ui/mainwindow.ui" line="530"/>
+        <location filename="../ui/mainwindow.ui" line="572"/>
         <source>Detect language automatically</source>
         <translation>Визначати мову автоматично</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="517"/>
-        <location filename="../ui/mainwindow.ui" line="533"/>
+        <location filename="../ui/mainwindow.ui" line="575"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Визначати мову автоматично, використовуючи регіональні стандарти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="500"/>
-        <location filename="../ui/mainwindow.ui" line="516"/>
+        <location filename="../ui/mainwindow.ui" line="610"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="386"/>
-        <location filename="../ui/mainwindow.ui" line="406"/>
+        <location filename="../ui/mainwindow.ui" line="445"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="53"/>
-        <location filename="../ui/mainwindow.ui" line="41"/>
+        <location filename="../ui/mainwindow.ui" line="44"/>
         <source>Task</source>
         <translation>Умова</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="74"/>
-        <location filename="../ui/mainwindow.ui" line="62"/>
+        <location filename="../ui/mainwindow.ui" line="65"/>
         <source>&amp;Variant:</source>
         <translation>&amp;Варіант:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="97"/>
-        <location filename="../ui/mainwindow.ui" line="85"/>
+        <location filename="../ui/mainwindow.ui" line="88"/>
         <source>&amp;Cities:</source>
         <translation>&amp;Міст:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="141"/>
         <location filename="../ui/mainwindow.ui" line="129"/>
         <source>Cost of travel from city to city</source>
@@ -254,5 +273,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="169"/>
         <location filename="../ui/mainwindow.ui" line="157"/>
         <source>Fill table with random numbers</source>
@@ -260,5 +278,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
         <location filename="../ui/mainwindow.ui" line="160"/>
         <source>Random</source>
@@ -266,5 +283,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="186"/>
         <location filename="../ui/mainwindow.ui" line="174"/>
         <source>Solve current task</source>
@@ -272,5 +288,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="189"/>
         <location filename="../ui/mainwindow.ui" line="177"/>
         <source>Solve</source>
@@ -278,5 +293,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="203"/>
         <location filename="../ui/mainwindow.ui" line="191"/>
         <source>Solution</source>
@@ -284,5 +298,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="212"/>
         <location filename="../ui/mainwindow.ui" line="200"/>
         <source>Solution steps</source>
@@ -290,18 +303,31 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="242"/>
-        <location filename="../ui/mainwindow.ui" line="230"/>
+        <location filename="../ui/mainwindow.ui" line="221"/>
+        <location filename="../ui/mainwindow.ui" line="424"/>
+        <source>Save solution to a file</source>
+        <translation>Зберегти розв&apos;язок у файл</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="224"/>
+        <source>Save Solution</source>
+        <translation>Зберегти</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="251"/>
+        <source>Go back to Task tab</source>
+        <translation>Повернутися до закладки &quot;Умова&quot;</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="254"/>
+        <source>Back to Task</source>
+        <translation>До умови</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="284"/>
         <source>&amp;File</source>
         <translation>&amp;Файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="249"/>
-        <location filename="../ui/mainwindow.ui" line="234"/>
-        <source>Save &amp;As...</source>
-        <translation>Зберегти &amp;як...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="277"/>
-        <location filename="../ui/mainwindow.ui" line="265"/>
+        <location filename="../ui/mainwindow.ui" line="316"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
